import glob
import os
from unidecode import unidecode
os.chdir("/Users/ciuffo/Documents/Projects/Gutenberg Clock/gutenzip take two/txt")
filelist = []
print "Populating title list"
for file in glob.glob("*.txt"):
    filelist.append(file)
titleList = []
for file in filelist:
    f = open(file,'r+')
    titleList.append([file,f.readline()])
    f.close()
print str(len(titleList))+" titles found"
utf8=[]
ascii=[]

print "Examining files"
for i in range(1,len(titleList)-1):

    #removes all UTF-8 files
    filenameloc = 0
    if "-0" in titleList[i][0]:
        filenameloc=titleList[i][0].find("-0")
    if ("-0" in titleList[i][0])and (titleList[i+1][0][:filenameloc]==titleList[i][0][:filenameloc]):
        utf8.append(titleList[i])


    dotloc= titleList[i][0].find(".")
    rawfilename = titleList[i][0][:dotloc]
    dotloc= titleList[i-1][0].find(".")
    prevfilename = titleList[i-1][0][:dotloc]
    dotloc= titleList[i+1][0].find(".")
    nextfilename = titleList[i+1][0][:dotloc]
    dashloc = nextfilename.find("-")
    if dashloc != -1:
        nextfilename=nextfilename[:dashloc]
    dashloc = prevfilename.find("-")
    if dashloc != -1:
        prevfilename=prevfilename[:dashloc]

    
    #This removes all the ascii files that have associated ISO8859-1 files
    if "-0" not in titleList[i][0] and "-8" not in titleList[i][0] and (rawfilename==prevfilename or rawfilename==nextfilename):
        #print prevfilename, nextfilename, rawfilename
        ascii.append(titleList[i])


print "removing UTF8 files"        
for i in utf8:
    titleList.remove(i)

print "removing ascii files that have associated ISO8859-1 files"
for i in ascii:
    titleList.remove(i)

nonenglish=[]
print "removing non-english files"
for title in titleList:
    f=open(title[0],'r+')
    language = "null"
    for line in f:
        if "anguage:" in line:
            if "English" in line or "english" in line:
                language="English"
            break
        if language != "null":
            break
    f.close()
    if language=="null":
        nonenglish.append(title)
        
for i in nonenglish:
    titleList.remove(i)

print str(len(titleList))+" files remian"
#Here are some functions that I used to get a survey of all of the files
#and to locate any outliers with funny formatting

#identifying how many books are formatted which way is only useful during
#initial investigation, but they don't take very long, so I left them in for fun
    
posessive = []
for i in titleList:
    if "Gutenberg's" in i[1]:
        posessive.append(i)
print str(len(posessive))+" files have \'Gutenberg's\' in the first line"


gutenberg = []
for i in titleList:
	if "Gutenberg " in i[1]:
		gutenberg.append(i)
print str(len(gutenberg))+" files have \'Gutenberg\' in the first line"

other = []
for i in titleList:
	if ("Gutenberg " not in i[1]) and ("Gutenberg's" not in i[1]):
		other.append(i)

print str(len(other))+" files have neither"
ebook = []
ebookof = []
for i in gutenberg:
    if "eBook," in i[1] or "EBook," in i[1]:
        ebook.append(i)
    elif "eBook of" in i[1] or "EBook of" in i[1]:
        ebookof.append(i)
    else:
        titleList.remove(i)
print str(len(ebook)) + " say \'ebook\'"
print str(len(ebookof)) + " say \'ebook of\'"

print "removing files that don't say Gutenberg in their first line"
for i in other:
    titleList.remove(i)
print str(len(titleList))+" files remain"


#remove headers and footers turn the first line into title, author

print "Removing headers and footers"
filename=0
for i in titleList:
    text=[]
    f = open(i[0],'r')
    fsave = open("headersremoved/"+str(filename)+".txt",'w')
    started = False
    stopped = False
    firstline=f.readline()
    secondLine="\r\n"

    #occasionally, the title bleeds on to the second or third line.
    templine = f.readline()
    while(templine[0]!='\r' and templine[0]!='\n'):
        secondLine = secondLine[:-2]+" "+templine
        templine = f.readline()
    
    
    if "eBook of" in firstline:
        fsave.write(firstline[firstline.find("eBook of")+9:-2]+' '+secondLine)
    elif "eBook" in firstline:
        fsave.write(firstline[firstline.find("eBook")+7:-2]+' '+secondLine)
    elif "EBook of" in firstline:
        fsave.write(firstline[firstline.find("EBook of")+9:-2]+' '+secondLine)
    elif "EBook" in firstline:
        fsave.write(firstline[firstline.find("EBook")+7:-2]+' '+secondLine)
    elif "Gutenberg's" in firstline:
        fsave.write(firstline[firstline.find("Gutenberg's")+12:-2]+' '+secondLine)
    else:
        print firstline
    

    for line in f:
        
        
        if "End of the Project Gutenberg EBook" in line or "End of Project Gutenberg's" in line or "***END OF THE PROJECT GUTENBERG " in line or "*** END OF THIS PROJECT " in line or "*** END OF THE PROJECT " in line:
            stopped = True
        if started and not stopped:
            fsave.write(line)

        #the START OF line will always end with this
        #I'm doing it this way in case that line rolls on to a second line down from where "START OF" can be found
        #12670-8.txt for some reason doesn't have a \r at the end of its line, so I need a special case
        if "***\r\n" in line or "***\n" in line:
            started = True

    #debugging step. Print out details on files that don't seem to fit the header/footer formatting       
    if stopped == False or started == False:
        print i,started,stopped
    filename=filename+1
    f.close()
    fsave.close()

print "Reformatting paragraphs"
for i in range(filename):
    f=open("headersremoved/"+str(i)+".txt",'r')
    fsave = open("shorterparagraphs/"+str(i)+".txt",'w')

    runningString = ""
    for line in f:
        #specially formatted lines tend to start with a space
        if (line[0]==" "):
            fsave.write(runningString+'\r\n')
            fsave.write(line)
            runningString = ""
        elif ((line[0]!='\r')and(line[0]!='\n')):
            runningString = runningString+line[:-2]+' '
        else:
            #print repr(line)
            fsave.write(runningString+'\r\n')
            fsave.write('\r\n')
            runningString=""
    f.close()
    fsave.close()

#Detect and remove files that have lines that are too long with no spaces
#(basically all Chinese files)


weirdlines=[]

print "Removing files that have strange lines of text that are too long with no spaces (Chinese)"
for i in range(0,filename):
    f=open("shorterparagraphs/"+str(i)+".txt",'r')
    runningString = ""
    leaveloop=0
    for line in f:
    
        if len(line)>6000:
            lastSpace = len(line)
            for j in range(len(line),0,-1):
 
                if (lastSpace-j)>5000 and line[j]==' ':
                    #print line[j:lastSpace]
                    #print len(line[j:lastSpace])
                    #raw_input()
                    lastSpace=j
                if (lastSpace-j)>6500:
                    weirdlines.append(i)
                    leaveloop=1
                    break
                if leaveloop==1:
                    break
            if leaveloop==1:
                break
        if leaveloop==1:
            break
            #print line[0:lastSpace]
            #print len(line[0:lastSpace])
            #raw_input()
            
    f.close()


goodlines=range(filename)
for i in weirdlines:
    goodlines.remove(i)

print "Chopping up lines that are longer than 5000 characters long into several smaller ones"

#there are a few files missing from the original count, so need to adopt new numbering system
savename = 0
for i in goodlines:
    f=open("shorterparagraphs/"+str(i)+".txt",'r')
    fsave = open("choppedlines/"+str(savename)+".txt",'w')
    savename+=1
    runningString = ""
    leaveloop=0
    for line in f:
    
        if len(line)>6000:
            splitline = []
            lastSpace = len(line)
            #run backwards from the end of the line and find the nearest space to the 5000 character
            #mark. Split the line there.
            for j in range(len(line),-1,-1):
                if (lastSpace-j)>5000 and line[j]==' ':
                    
                    splitline.append(line[j:lastSpace])
                    lastSpace=j
            #handle last bit at the beginning of the line
            splitline.append(line[0:lastSpace])

            #write chopped up line to file

            for k in range(len(splitline)-1,-1,-1):
                fsave.write(splitline[k]+'\r\n\r\n')
        else:
            fsave.write(line)
    fsave.close()           
    f.close()

print "Converting characters to ASCII"
for i in range(len(goodlines)):
    f=open("choppedlines/"+str(i)+".txt",'r')
    fsave = open("cleanedcharacters/"+str(i)+".txt",'w')
 
    cleanedline = ""

    for line in f:
    
        cleanedline = unidecode(line)
        fsave.write(cleanedline);
    fsave.close()           
    f.close()

print "Removing leading and trailing whitespace"
for i in range(len(goodlines)):
    f=open("cleanedcharacters/"+str(i)+".txt",'r')
    fsave = open("nowhitespace/"+str(i)+".txt",'w')

    for line in f:
    
         fsave.write(line.lstrip(' ').rstrip(' '));
    fsave.close()           
    f.close()

